function savefig(hf, fpath, hstyle)
%% SAVEFIG
%
% Inputs:
%
%   HF                      Description of argument HF
% 
%   FPATH                   Description of argument FPATH
% 
%   HSTYLE                  Description of argument HSTYLE
%
% Authors:
%   Philipp Tempel <philipp.tempel@ls2n.fr>



%% Parse arguments

% SAVEFIG(HF, FPATH)
% SAVEFIG(HF, FPATH, HSTYLE)
narginchk(2, 3);

% SAVEFIG(___)
nargoutchk(0, 0);

% SAVEFIG(HF, FPATH)
if nargin < 3 || isempty(hstyle)
  hstyle = 'T-RO Figure';
end



%% Algorithm

% Export figure in original format
saveas( ...
    hf ...
  , ensuredir(sprintf(fpath, 'fig')) ...
);

set(hf, 'Renderer', 'Painters', 'RendererMode', 'manual');

% Export figure for paper
hgexport( ...
    hf ...
  , 'temp_dummy' ...
  , hgexport('readstyle', hstyle) ...
  , 'applystyle', true ...
);
drawnow();

exportgraphics( ...
    hf ...
  , ensuredir(sprintf(fpath, 'pdf')) ...
  , 'ContentType'     , 'vector' ...
  , 'BackgroundColor' , 'none' ...
  , 'Resolution'      , 150 ...
);
exportgraphics( ...
    hf ...
  , ensuredir(sprintf(fpath, 'eps')) ...
  , 'ContentType'     , 'vector' ...
  , 'BackgroundColor' , 'none' ...
  , 'Resolution'      , 150 ...
);
exportgraphics( ...
    hf ...
  , ensuredir(sprintf(fpath, 'png')) ...
  , 'BackgroundColor' , 'none' ...
  , 'Resolution'      , 150 ...
);



end

%------------- END OF CODE --------------
% Please send suggestions for improvement of this file to the original author as
% can be found in the header. Your contribution towards improving this function
% will be acknowledged.
